package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.custom.base.impl.FindConverterDao;
import com.jasamedika.medifirst2000.entities.RisikoKerjaRuangan;
import com.jasamedika.medifirst2000.vo.RisikoKerjaRuanganVO;

/**
 * Converter class RisikoKerjaRuangan
 * 
 * @author Askur
 */
@Component
public class RisikoKerjaRuanganConverter extends FindConverterDao implements
		BaseVoConverter<RisikoKerjaRuanganVO, RisikoKerjaRuangan> {

	public RisikoKerjaRuangan transferVOToModel(RisikoKerjaRuanganVO vo, RisikoKerjaRuangan model) {
		if (null == model)
			model = new RisikoKerjaRuangan();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, RisikoKerjaRuangan.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;

	}

	public List<RisikoKerjaRuanganVO> transferListOfModelToListOfVO(List<RisikoKerjaRuangan> models,
			List<RisikoKerjaRuanganVO> vos) {
		if (null == vos)
			vos = new ArrayList<RisikoKerjaRuanganVO>();

		if (null == models)
			return vos;

		for (RisikoKerjaRuangan model : models) {
			RisikoKerjaRuanganVO vo = new RisikoKerjaRuanganVO();
			transferModelToVO(model, vo);
			vos.add(vo);
		}

		return vos;
	}

	public RisikoKerjaRuanganVO transferModelToVO(RisikoKerjaRuangan model, RisikoKerjaRuanganVO vo) {
		if (null == vo)
			vo = new RisikoKerjaRuanganVO();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, RisikoKerjaRuanganVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
